import processing.sound.*;

//Bilder Variablen
PImage menuBild;
PImage bildhase;
PImage bildHinter;
PImage bildpilz;
PImage bildstein;
PImage bildei;

// Schriftarten / Fonts
PFont easterTime;
PFont easterBoost;

// Spieler Koordinaten
int playerX = 20;
int playerY = 570;
int speed = 25;
int jumpSpeed = 15;

//Pilz Koordinaten
float pilzX;
int pilzY;
float pilzGeschwindigkeit;

//Stein Koordinaten
float steinX = 470;
int steinY = 650;
float steinGeschwindigkeit;

// Hintergrund Koordinaten
int xbildHinter = 0;

// Spielzustand (CONTINOUS MODE) & Score (gesammelte Eier)
int state = 0;
int score = 0;

// Musik & Töne
SoundFile menuMusik;
SoundFile spielMusik;
SoundFile coinSound;
SoundFile jump;
SoundFile damage;
SoundFile extraleben;

// Spielersprung Variablen (Physik)
boolean onGround; // Wert für ob der Spieler am Boden ist
float sprungKraft; // Die Kraft, die sich auf die Y-Koordinate vom Spieler auswirkt
float schwerkraft = 1.8; // Die Schwerkraft die sich auf die Sprungkraft auswirkt

// Ei Variablen
float eiX, eiY;
float eiGeschwindigkeit;
boolean eiEingesammelt = false;

// Koordinate vom Boden (zum berechnen)
int groundY = 800;

int leben; // Leben während dem Spiel
int maximaleLeben = 3; // variable für wie viele leben der spieler hat

// Text der beim erklärungsscreen/state angezeigt wird, \n ist ein Satz für einen Absatz
String textErklaerung =
  "\n\nEntwickler: Mylene Kreuzer, Anna Schnidrig & Elena Zimmermann \nSteuerung:\n - Springen: Leertaste\n\nGegner: Pilze & Steine\nZiel: Sammle so viele Ostereier wie moeglich\n\nExtraleben: 3 Ostereier";

void setup() {
  size(1000, 1000);

  // Bilder laden & vergrössern/verkleinern
  bildHinter = loadImage("./bild/Hinter.jpg");
  bildHinter.resize(1000, 1000);

  menuBild = loadImage("./bild/menu.png");
  menuBild.resize(width, height);

  bildhase = loadImage("./bild/hase.png");
  bildhase.resize(bildhase.width/11, bildhase.height/11);


  bildpilz = loadImage("./bild/pilz.png");
  bildpilz.resize(bildpilz.width/14, bildpilz.height/14);

  // Pilzvariablen werden gesetzt
  pilzX = width-bildpilz.width;
  pilzY = groundY-bildpilz.height;
  pilzGeschwindigkeit = 10;

  // Steinvariablen werden gesetzt
  bildstein = loadImage("./bild/stein.png");
  bildstein.resize(bildstein.width/13, bildstein.height/13);


  bildei = loadImage("./bild/eggspot1.png");

  // Töne werden geladen
  menuMusik = new SoundFile(this, "./audio/menu.wav");
  spielMusik =new SoundFile(this, "./audio/spiel.wav");
  damage = new SoundFile(this, "./audio/damage.wav");
  jump =new SoundFile(this, "./audio/jump.wav");
  coinSound = new SoundFile(this, "./audio/coin.wav");
  extraleben = new SoundFile(this, "./audio/extraleben.wav");

  // schriftarten werden erstellt
  easterBoost = createFont("./schriftarten/EasterGift.ttf", 100);
}

void draw() {

  // Sprungfunktion
  if (keyPressed) {
    if (key == ' ' && onGround) { // falls der spieler leertaste drückt und springt
      sprungKraft=-20; // sprungkraft negativ -> y-koordinat geht hoch
      playerY-=90; // Spieler wird ein bisschen höher gesetzt, damit der computer denkt, dass der spieler nicht mehr am boden ist
      onGround = false; // spieler ist nun nicht mehr am boden
      jump.play(); // jump ton wird abgespielt
    }
  }

  /*
    In dieser if-Abfrage werden die verschiedenen Menüs & Bilder generiert, je nach State ( Spielzustand )
   State Nummer 0 : Menü
   State Nummer 1 : Spiel
   State Nummer 2 : Game Over / Spielende
   State Nummer 3 : Spielanleitung
   */
  if (state==0) { // STATE 0 / MENÜ
    if (frameCount != 1) return; // Code wird nur einmal ausgeführt
    // Menübild
    imageMode(CORNER);
    image(menuBild, 0, 0);

    // Spieltitel
    textAlign(CENTER);
    textSize(100);
    textFont(easterBoost);
    fill(0, 100, 0);
    text("EasterHunt", 525, height/2);
    fill(0, 150, 0);
    text("EasterHunt", 515, height/2);

    // Einleitungstext
    textSize(70);
    fill(255);
    text("Rechtsklick zum Starten", 515, height-100);
    
    // Text
    textSize(30);
    fill(255);
    text("Druecke 'a' fuer die Spielanleitung", 515, height-50);

    if (!(menuMusik.isPlaying())) menuMusik.play(); // Falls die Menu musik noch nicht spielt wird sie gestartet
  } else if (state==1) {

    if (frameCount == 1) { ///////////////// Dieser Abschnitt wird zu beginn des spiels gemacht, was?:  startwerte werden gesetzt
      leben=maximaleLeben; // Leben zurückgesetzt
      score = 0; // Score auf 0

      // spielerstandardwerte
      playerX=20;
      playerY=groundY-bildhase.height;
      onGround = true;

      // steinstandardwerte
      steinX = width+=Math.round(random(100, 200))*3;
      steinY = groundY-bildstein.height;
      steinGeschwindigkeit=10;

      // ei-standardwerte
      eiX = width+ 500;
      eiY = groundY-bildei.height;
      eiGeschwindigkeit = 10;
    } ////////////////////////////////////////////

    // Hintergrund anzeigen &  verschieben
    xbildHinter -= 5;// Hintergrund nach linksverschieben
    if (xbildHinter<=0-bildHinter.width) { // Falls der Hintergrund aus dem Fenster geht
      xbildHinter+=bildHinter.width;
    }

    // Hintergründe werden angezeigt (drei hintergründe nebeneinander damit man nicht neben den hintergründen beim verschieben die leere sieht)
    image(bildHinter, xbildHinter, 0);
    image(bildHinter, xbildHinter+bildHinter.width, 0);
    image(bildHinter, xbildHinter-bildHinter.width, 0);

    // die verschiedenen objekte (hase, pilz, stein, ei) werden gezeichnet
    image(bildhase, playerX, playerY);
    image(bildpilz, pilzX, pilzY);
    image(bildstein, steinX, steinY);
    image(bildei, eiX, eiY);

    // der score wird angezeigt
    textSize(30);
    fill(255);
    text("Eier gesammelt: " + score, 525, 100);



    // die verschiedenen objekte werden je nach geschwindigkeit (variable) bewegt
    pilzX-=pilzGeschwindigkeit;
    steinX-=steinGeschwindigkeit;
    eiX-=eiGeschwindigkeit;

    // falls die objekte sich aus dem spielfeld bewegen werden sie wieder random nach rechts verschoben
    if (pilzX+bildpilz.width < 0) pilzX = width + int(random(0, 300));
    if (steinX+bildstein.width < 0) steinX = width + int(random(200, 500));
    if (eiX+bildei.width < 0) eiX = width +bildei.width;

    // Falls der Spieler am Springen ist (bzw über dem Boden y=550 ist)
    if (playerY < groundY-bildhase.height) {
      playerY+=sprungKraft; // Spielerhöhe wird mit sprungkraft addiert
      sprungKraft+=schwerkraft; // sprungKraft wird mit Schwerkraft addiert (dadurch geht die sprungkraft langsam wieder runter)
      if (sprungKraft>10)sprungKraft=10; // damit die gravitation nicht zu stark wird, wird die sprungkraft hier begrenzt
    } else {
      onGround=true;
    }


    for (int i = playerX; i < playerX+bildhase.width; i++) for (int b = playerY; b < playerY+bildhase.height; b++) { // eine for schleife durch den bereich der x & y koordinat vom spieler (also von der oberen linken ecke zur unteren rechte)
      boolean pilzBeruehrt = i > pilzX && i < pilzX+bildpilz.width && b > pilzY && b < pilzY+bildpilz.height; // variable für ob die koordinaten vom spieler im pilz sind
      boolean eiBeruehrt = i > eiX && i < eiX+bildei.width && b > eiY && b < eiY+bildei.height;  // variable für ob die koordinaten vom spieler im ei sind
      boolean steinBeruehrt = i > steinX && i < steinX+bildstein.width && b > steinY && b < steinY+bildstein.height;  // variable für ob die koordinaten vom spieler im stein sind

      // Dieser Code Abteil sollte verständlich sein (falls der spieler berührt...)
      if (pilzBeruehrt) {
        pilzX = width + int(random(0, 300)); // objekt wieder nach rechts
        leben--;
        damage.play();
      }

      if (steinBeruehrt) {
        steinX = width + int(random(0, 500)); // objekt wieder nach rechts
        leben--;
        damage.play();
      }

      if (eiBeruehrt) {
        eiX = width +bildei.width; // objekt wieder nach rechts
        coinSound.play();
        score++;

        // spiel wird schneller
        pilzGeschwindigkeit+=random(0, 0.8);
        steinGeschwindigkeit+=random(0, 0.8);

        if ((score % 3) ==0 && leben < 5) { // alle 3 eier wird falls der spieler nicht mehr als 5 leben hat eines hinzugefügt
          leben++; // leben um 1 höher
          coinSound.stop();
          extraleben.play(); // spezialsound wird abgespielt
        }
      }
    }

    // lebensanzeige
    stroke(255, 0, 0);
    strokeWeight(10);
    line(0, 30, width, 30);
    stroke(0, 255, 0);
    strokeWeight(10);
    line(0, 30, parseFloat(leben)/parseFloat(maximaleLeben+1)*parseFloat(width), 30); // grüne linie (länge wird mit dreisatz berechnet)
    strokeWeight(1);

    // anzahl leben als text
    textSize(40);
    fill(255);
    text(leben, 525, 40);

    // falls der spieler keine leben mehr hat
    if (leben == 0) {
      frameCount=0;
      spielMusik.stop();
      if (!(menuMusik.isPlaying())) menuMusik.play();
      state++; // nächster state
    }
  } else if (state == 2) { // STATE2 : GAME OVER
    if (frameCount != 1) return;
    // hintergrundbild
    imageMode(CORNER);
    image(menuBild, 0, 0);

    // gameover text
    textAlign(CENTER);
    textSize(100);
    textFont(easterBoost);
    fill(0, 100, 0);
    text("GAME OVER", 525, height/2);
    fill(0, 150, 0);
    text("GAME OVER", 515, height/2);

    // score text
    textSize(60);
    fill(0, 150, 0);
    text("SCORE: " + score, 515, height/2+100);

    // rechtsklick... text
    textSize(70);
    fill(255);
    text("Rechtsklick zum Neustarten", 515, height-100);
  } else if (state == 3) { // state 3 = game over
    // hintergrund
    imageMode(CORNER);
    image(menuBild, 0, 0);

    // titel
    textAlign(LEFT);
    textSize(50);
    fill(0);
    text("EasterHunt - Anleitung", 50, 75);
    textAlign(CENTER);

    // erklaerungstext
    textAlign(LEFT);
    textSize(30);
    fill(255);
    text(textErklaerung, 50, 50);
    textAlign(CENTER);

    // erklaerungsbilder
    imageMode(CENTER);
    image(bildpilz, 355, 280+55);
    image(bildstein, 355+60, 280+55);
    image(bildhase, 355+60, 250-50+55, 30, 50);
    image(bildei, 355+280, 250+80+55);
    imageMode(CORNER);

    // zuereck zum menu - Text
    textSize(70);
    fill(255);
    text("Rechtsklick : Zuereck zum Menu", 515, height-100);
  }
}

void mousePressed() {
  if (!(mouseButton == RIGHT)) return; //falls es kein rechtsklick ist wird die funktion gestoppt
  if (state==0) { // falls menü aktiv ist

    frameCount=0;
    state++; // naechster state
    menuMusik.stop(); // menu musik wird gestoppt
    if (!(spielMusik.isPlaying())) spielMusik.play(); // gamemusik gestartet
  } else if (state==2) { // state 2 -> game over

    frameCount=0;
  } else if (state == 3) { // state 3 -> erklaerungsscreen

    state = 0;
    frameCount = 0;
  }
}

void keyPressed() {
  if (state==0 && key=='a') state=3;
}
